datablock AudioProfile(tf2SyringeFireSound)
{
   filename    = "./syringeFire.wav";
   description = AudioClosest3d;
   preload = true;
};


//arrow trail
datablock ParticleData(tf2SyringeTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 0 0 0.2";
	colors[1]	= "1 0 0 0.0";
	sizes[0]	= 0.05;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(tf2SyringeTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = tf2SyringeTrailParticle;

   useEmitterColors = true;
   uiName = "Blutsauger Trail";
};

datablock ParticleData(tf2SyringeStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "./heal_white";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0 0 0.9";
	colors[1]     = "1 0 0 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(tf2SyringeStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tf2SyringeStickExplosionParticle";

   useEmitterColors = true;
   uiName = "Blutsauger Stick";
};
datablock ExplosionData(tf2SyringeStickExplosion)
{
   //explosionShape = "";
   soundProfile = arrowHitSound;

   lifeTimeMS = 150;

   particleEmitter = tf2SyringeStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0.5;
   lightEndRadius = 0;
   lightStartColor = "1 0 0";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("TF2SyringeDirect",   '<bitmap:add-ons/Weapon_TF2MedicPack/CI_syringe> %1',    '%2 <bitmap:add-ons/Weapon_TF2MedicPack/CI_syringe> %1',0.5,1);
datablock ProjectileData(tf2SyringeDrainProjectile)
{
   projectileShapeName = "./needle.dts";

   directDamage        = 6;
   directDamageType    = $DamageType::TF2SyringeDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::TF2SyringeDirect;

   explosion             = arrowExplosion;
   stickExplosion        = tf2SyringeStickExplosion;
   bloodExplosion        = tf2SyringeStickExplosion;
   particleEmitter       = tf2SyringeTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 1;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   uiName = "Blutsauger Syringe";
};


//////////
// item //
//////////
datablock ItemData(tf2SyringeDrainItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Blutsauger.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "The Blutsauger";
	iconName = "./icon_blutsauger";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	 // Dynamic properties defined by the scripts
	image = tf2SyringeDrainImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(tf2SyringeDrainImage)
{
   // Basic Item properties
   shapeFile = "./Blutsauger.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "10 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tf2SyringeDrainItemItem;
   ammo = " ";
   projectile = tf2SyringeDrainProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = tf2SyringeDrainItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Check";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= tf2SyringeFireSound;

	stateName[3]			= "Check";
	stateTransitionOnTriggerUp[3]	= "StopFire";
	stateTransitionOnTriggerDown[3]	= "Fire";

	stateName[4]                    = "StopFire";
	stateTransitionOnTimeout[4]     = "Ready";
	stateTimeoutValue[4]            = 0.2;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;
	stateScript[4]                  = "onStopFire";
};

function tf2SyringeDrainImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2,plant);
	
	%projectile = %this.projectile;
	%spread = 0.001;
	%scale = getWord(%obj.getScale(),2);

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = vectorScale(%velocity,%scale);
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	%p.setScale(%scale SPC %scale SPC %scale);
	
	return %p;
}

function tf2SyringeDrainProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;
   
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getType() & $TypeMasks::PlayerObjectType && %col.getType() & $TypeMasks::PlayerObjectType)
   {
      %firer = %obj.sourceObject;
      %col.damage(%obj, %pos, %directDamage, %damageType);
      
      if(%firer.getWhiteOut() < 0.2)
         %firer.setWhiteOut(0.2);
      
      if(getSimTime() - %firer.lastHealImageTime > 500)
      {
         %firer.mountImage(healImage,3);
         %firer.lastHealImageTime = getSimTime();
      }
      
      if(%firer.getDamageLevel() > 0)
      {
         if(%firer.getDamageFlash() < 0.3)
            %firer.setDamageFlash(0.3);
         
         %firer.addHealth(3);
      }
      else
      {
         %firer.setHealth(%firer.dataBlock.maxDamage);
      }
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}