datablock AudioProfile(TF2MedigunActivateSound)
{
   filename    = "./medigunActivate.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioDescription(AudioClosestQuiet3d : AudioClosest3d)
{
	volume = 0.75;
};

datablock AudioProfile(TF2MedigunUberOnSound)
{
   filename    = "./medigunUberOn.wav";
   description = AudioClosestQuiet3d;
   preload = true;
};

datablock AudioProfile(TF2MedigunUberOffSoundA)
{
   filename    = "./medigunUberOffA.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(TF2MedigunUberOffSoundB)
{
   filename    = "./medigunUberOffB.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(TF2MedigunHealParticleA)
{
	textureName          = "base/data/particles/dot";
	dragCoefficient      = 10.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = 0.0;
	spinRandomMax = 0.0;
	useInvAlpha   = false;

	colors[0]	= "0.9 0.0 0.0 0.0";
	colors[1]	= "0.9 0.2 0.1 0.3";
	colors[2]	= "0.9 0.2 0.1 0.3";
	colors[3]	= "0.9 0.0 0.0 0.0";

	sizes[0]	= 0.2;
	sizes[1]	= 0.4;
	sizes[2]	= 0.4;
	sizes[3]	= 0.4;

	times[0]	= 0.0;
	times[1]	= 0.3;
	times[2]	= 0.7;
	times[3]	= 1.0;
};

datablock ParticleEmitterData(TF2MedigunHealEmitterA)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = TF2MedigunHealParticleA;   
   
   useEmitterColors = true;
   
   uiName = "Medigun Heal A";
};

datablock ParticleData(TF2MedigunHealParticleB)
{
   dragCoefficient      = 6.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   textureName          = "./heal_white";
   colors[0]     = "0.9 0.0 0.0 1.0";
   colors[1]     = "0.9 0.3 0.3 1.0";
   colors[2]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 0.3;
   sizes[1]      = 0.3;
   sizes[2]      = 0.2;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(TF2MedigunHealEmitterB)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 30;
   ejectionVelocity = 0.6;
   ejectionOffset   = 0.4;
   velocityVariance = 0.3;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TF2MedigunHealParticleB";

   uiName = "Medigun Heal B";
};

datablock ProjectileData(TF2MedigunHealProjectileA)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = "";
   particleEmitter     = Tf2MedigunHealEmitterA;
   explodeOnDeath = false;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   sound = "";

   muzzleVelocity      = 16;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 625;
   fadeDelay           = 490;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "1.0 1.0 0.5";

   uiName = "Medigun Beam A"; 
};

datablock ProjectileData(TF2MedigunHealProjectileB)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = "";
   particleEmitter     = Tf2MedigunHealEmitterB;
   explodeOnDeath = false;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = true;

   sound = "";

   muzzleVelocity      = 16;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 625;
   fadeDelay           = 490;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "1.0 1.0 0.5";

   uiName = "Medigun Beam B"; 
};

//explosion
datablock ParticleData(TF2MedigunUberExplosionParticle : radioWaveExplosionParticle)
{
	colors[0]     = "0.9 0 0 1";
	colors[1]     = "0.9 0 0 1";
	colors[2]     = "0.9 0 0 0";
	
	sizes[0]      = 0.25;
	sizes[1]      = 0.125;
	sizes[2]      = 0.0;
};

datablock ParticleEmitterData(TF2MedigunUberExplosionEmitter : radioWaveExplosionEmitter)
{
   particles = "TF2MedigunUberExplosionParticle";
   uiName = "";
   useEmitterColors = false;
};

datablock ParticleEmitterData(TF2MedigunUberReadyEmitter : radioWaveExplosionEmitter)
{
   particles = "TF2MedigunUberExplosionParticle";
   ejectionOffset   = 0.25;
   uiName = "";
   useEmitterColors = false;
};


datablock ExplosionData(TF2MedigunUberExplosion : radioWaveExplosion)
{
   particleEmitter = TF2MedigunUberExplosionEmitter;
   
   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 0 0";
   lightEndColor = "0 0 0";
};

datablock ProjectileData(TF2MedigunUberProjectile : radioWaveProjectile)
{
   explosion           = TF2MedigunUberExplosion;
   explodeOnDeath = true;
   
   sound = "";

   armingDelay         = 0;
   lifetime            = 10;
   fadeDelay           = 90;
   
   uiName = ""; 
};

datablock ParticleData(PlayerTF2HealParticle : PlayerTeleportParticleB)
{
	textureName = "./heal_white";
	
	colors[0]     = "0.9 0.0 0.0 1.0";
	colors[1]     = "0.9 0.3 0.3 1.0";
	colors[2]     = "0.9 0.0 0.0 0.0";
	
	lifetimems = 750;
	lifetimevariancems = 250;	
};

datablock ParticleEmitterData(PlayerTF2HealEmitter : PlayerTeleportEmitterB)
{
	particles = PlayerTF2HealParticle;
	uiName = "Medigun Overheal";
};

datablock ParticleEmitterData(PlayerTF2UberEmitter : PlayerTeleportEmitterB)
{
	particles = radioWaveExplosionParticle;
	uiName = "Medigun Ubercharge";
	
	useEmitterColors = true;
};

datablock ShapeBaseImageData(PlayerTF2HealImage : PlayerTeleportImage)
{
	stateName[0]				= "Ready";
	stateTransitionOnTimeout[0]		= "Check";
	stateTimeoutValue[0]			= 0.1;

	stateName[1]				= "Check";
	stateTransitionOnTimeout[1]		= "Check";
	stateWaitForTimeout[1]			= false;
	stateTimeoutValue[1]			= 0.1;
	stateEmitter[1]				= PlayerTF2HealEmitter;
	stateEmitterTime[1]			= 0.1;
	stateScript[1]				= "onCheck";
	
	firstPerson = 0;
	firstPersonParticles = 0;
};

function PlayerTF2HealImage::onCheck(%this,%obj,%slot)
{
	%obj.doOverhealDecay();
	if(%obj.tf2overheal <= 0 && !%obj.beingHealed)
		%obj.unMountImage(%slot);
}

datablock ShapeBaseImageData(PlayerTF2UberImage : PlayerTeleportImage)
{
	stateName[0]				= "Ready";
	stateTransitionOnTimeout[0]		= "Check";
	stateSound[0]				= TF2MedigunUberOnSound;
	stateTimeoutValue[0]			= 0.1;

	stateName[1]				= "Check";
	stateTransitionOnTimeout[1]		= "Check";
	stateTransitionOnNoAmmo[1]		= "NoCharge";
	stateTransitionOnLoaded[1]		= "End";
	stateWaitForTimeout[1]			= false;
	stateTimeoutValue[1]			= 0.1;
	stateEmitter[1]				= PlayerTF2UberEmitter;
	stateEmitterTime[1]			= 0.1;
	stateScript[1]				= "onCheck";
	
	stateName[2]				= "NoCharge";
	stateWaitForTimeout[2]			= 0;
	stateTransitionOnAmmo[2]		= "Ready";
	stateTransitionOnTimeout[2]		= "End";
	stateSound[2]				= TF2MedigunUberOffSoundA;
	stateEmitter[2]				= PlayerTF2UberEmitter;
	stateEmitterTime[2]			= 1.2;
	stateTimeoutValue[2]			= 1.2;
	stateScript[2]				= "onNoCharge";
	
	stateName[3]				= "End";
	stateScript[3]				= "onEnd";
	
	firstPerson = 0;
	firstPersonParticles = 0;
	
	doColorShift = true;
	colorShiftColor = "0.9 0 0 1";
};

function PlayerTF2UberImage::onMount(%this,%obj,%slot)
{
	//Ammo = Ubercharge
	//Loaded = Medic put gun away
	%obj.setImageAmmo(%slot,1);
	%obj.setImageLoaded(%slot,0);
	
	if(isObject(%obj.client))
	{
		if(isObject(%obj.client.minigame) && %obj.client.tdmTeam != -1 && %obj.client.tdmTeam !$= "")
			%col = getColorIDTable(%obj.client.minigame.teamCol[%obj.client.tdmTeam]);
		else
			%col = %obj.client.chestColor;
	}
	else
		%col = "1 1 1";
	
	%obj.setNodeColor("ALL",%col SPC 1);
	%obj.playAudio(1,TF2MedigunUberOnSound);
}

function PlayerTF2UberImage::onCheck(%this,%obj,%slot)
{
	if(%obj.usingUber && %obj.getMountedImage(0) != TF2MedigunImage.getID())
	{
		%obj.lastUberUpdate = getSimTime();
		%obj.setImageLoaded(%slot,1);
		return;
	}
	
	%obj.setDamageFlash(0.3);
	
	if((!%obj.usingUber && !%obj.beingHealed) || (%obj.usingUber && %obj.tf2Ubercharge <= 0) || (!%obj.usingUber && %obj.beingHealed && !%obj.lastTF2Healer.usingUber))
		%obj.setImageAmmo(%slot,0);
}

function PlayerTF2UberImage::onNoCharge(%this,%obj,%slot)
{
	if(isObject(%obj.client))
	{
		if(isObject(%obj.client.minigame) && %obj.client.tdmTeam != -1 && %obj.client.tdmTeam !$= "")
			%col = getColorIDTable(%obj.client.minigame.teamCol[%obj.client.tdmTeam]);
		else
			%col = %obj.client.chestColor;
	}
	else
		%col = "1 1 1";
	
	%obj.setNodeColor("ALL",vectorScale(%col,0.75) SPC 1);
	%obj.playAudio(1,MedigunUberOffSoundA);
}

function PlayerTF2UberImage::onEnd(%this,%obj,%slot)
{
	serverPlay3d(TF2MedigunUberOffSoundB,%obj.getPosition());
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
	
	%obj.unMountImage(%slot);
}

datablock ItemData(TF2MedigunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./medigunitem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TF2 Medigun";
	iconName = "./icon_medigun";
	doColorShift = true;
	colorShiftColor = "0.15 0.15 0.15 1.000";

	 // Dynamic properties defined by the scripts
	image = TF2MedigunImage;
	canDrop = true;
	
	variableStore = "tf2Ubercharge";
	variableInitial = 0;
	variableReplace = 0;
};

datablock ShapeBaseImageData(TF2MedigunImage)
{
   // Basic Item properties
   shapeFile = "./medigun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0.1";
   eyeOffset = "0.4 0.55 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   className = "WeaponImage";
   item = medigunItem;
   
   // Projectile && Ammo.
   item = TF2MedigunItem;
   ammo = " ";
   projectile = TF2MedigunHealProjectileA;
   projectileType = Projectile;

   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = TF2MedigunItem.colorShiftColor;

   // Initial start up state
	stateName[0]                       = "Activate";
	stateSound[0]                      = weaponSwitchSound;
	stateTransitionOnTimeout[0]        = "CheckUber";
	stateTimeoutValue[0]               = 0.2;

	stateName[1]                       = "CheckUber";
	stateTransitionOnLoaded[1]         = "StartupUber";
	stateTransitionOnNotLoaded[1]      = "Startup";
	
	stateName[2]                       = "Startup";
	stateAllowImageChange[2]           = true;
	stateTransitionOnTimeout[2]        = "Ready";
	stateTimeoutValue[2]               = 0.3;
	stateSequence[2]                   = "Ready";
	
	stateName[3]                       = "Ready";
	stateTransitionOnTimeout[3]        = "Ready";
	stateTransitionOnTriggerDown[3]    = "CheckFire";
	stateAllowImageChange[3]           = true;
	stateWaitForTimeout[3]             = false;
        stateTimeoutValue[3]               = 0.1;
	stateScript[3]                     = "onReady";
        stateTransitionOnTimeout[3]        = "Ready";
	
	stateName[4]                       = "CheckFire";
	stateTransitionOnTimeout[4]        = "CheckFire";
	stateTransitionOnAmmo[4]           = "StartFire";
	stateTransitionOnTriggerUp[4]      = "Ready";
        stateTimeoutValue[4]               = 0.1;
	stateScript[4]                     = "onCheckFire";
	stateAllowImageChange[4]           = true;
	
	stateName[5]                       = "StartFire";
	stateTimeoutValue[5]               = 0.1;
	stateTransitionOnTimeout[5]        = "Fire";
	stateTransitionOnTriggerUp[5]      = "StopFire";
	stateWaitForTimeout[5]             = true;
	stateAllowImageChange[5]           = true;
	stateScript[5]                     = "onStartFire";
	stateSequence[5]                   = "ChargeOn";

	stateName[6]                       = "Fire";
	stateTransitionOnTriggerUp[6]      = "StopFire";
	stateTransitionOnNoAmmo[6]         = "StopFire";
	stateTransitionOnTimeout[6]        = "Fire";
	stateTransitionOnLoaded[6]         = "FireUber";
	stateTimeoutValue[6]               = 0.05;
	stateWaitForTimeout[6]             = true;
	stateFire[6]                       = true;
	stateAllowImageChange[6]           = true;
	stateScript[6]                     = "onFire";
	
	stateName[7]                       = "StopFire";
	stateScript[7]                     = "onStopFire";
	stateTransitionOnTimeout[7]        = "Ready";
	stateTimeoutValue[7]               = 0.1;
	stateWaitForTimeout[7]             = true;
	stateAllowImageChange[7]           = true;
	stateSequence[7]                   = "ChargeOff";
	
	//States with Ubercharged emitter on
	
	stateName[8]                       = "StartupUber";
	stateScript[8]                     = "onStartupUber";
	stateAllowImageChange[8]           = true;
	stateTransitionOnTimeout[8]        = "ReadyUber";
	stateTimeoutValue[8]               = 0.3;
	stateSequence[8]                   = "Ready";
	stateEmitter[8]                    = TF2MedigunUberReadyEmitter;
	stateEmitterTime[8]                = 0.3;
	stateEmitterNode[8]                = "muzzleNode";
	
	stateName[9]                       = "ReadyUber";
	stateTransitionOnTriggerDown[9]    = "CheckFireUber";
	stateTransitionOnNotLoaded[9]      = "Ready";
	stateAllowImageChange[9]           = true;
	stateWaitForTimeout[9]             = false;
        stateTimeoutValue[9]               = 1;
        stateTransitionOnTimeout[9]        = "ReadyUber";
	stateEmitter[9]                    = TF2MedigunUberReadyEmitter;
	stateEmitterTime[9]                = 1;
	stateScript[9]                     = "onReady";
	stateEmitterNode[9]                = "muzzleNode";
	
	stateName[10]                      = "CheckFireUber";
	stateTransitionOnTimeout[10]       = "CheckFireUber";
	stateTransitionOnAmmo[10]          = "StartFireUber";
	stateTransitionOnTriggerUp[10]     = "ReadyUber";
        stateTimeoutValue[10]              = 0.1;
	stateScript[10]                    = "onCheckFire";
	stateAllowImageChange[10]          = true;
	stateEmitter[10]                   = TF2MedigunUberReadyEmitter;
	stateEmitterTime[10]               = 0.1;
	stateEmitterNode[10]               = "muzzleNode";
	
	stateName[11]                      = "StartFireUber";
	stateTimeoutValue[11]              = 0.1;
	stateTransitionOnTimeout[11]       = "FireUber";
	stateTransitionOnTriggerUp[11]     = "StopFireUber";
	stateWaitForTimeout[11]            = true;
	stateAllowImageChange[11]          = true;
	stateScript[11]                    = "onStartFire";
	stateSequence[11]                  = "ChargeOn";
	stateEmitter[11]                   = TF2MedigunUberReadyEmitter;
	stateEmitterTime[11]               = 0.1;
	stateEmitterNode[11]               = "muzzleNode";

	stateName[12]                      = "FireUber";
	stateTransitionOnTriggerUp[12]     = "StopFireUber";
	stateTransitionOnNoAmmo[12]        = "StopFireUber";
	stateTransitionOnTimeout[12]       = "FireUber";
	stateTransitionOnNotLoaded[12]         = "Fire";
	stateTimeoutValue[12]              = 0.05;
	stateWaitForTimeout[12]            = true;
	stateFire[12]                      = true;
	stateAllowImageChange[12]          = true;
	stateScript[12]                    = "onFireUber";
	stateEmitter[12]                   = TF2MedigunUberReadyEmitter;
	stateEmitterTime[12]               = 0.05;
	stateEmitterNode[12]               = "muzzleNode";
	
	stateName[13]                      = "StopFireUber";
	stateScript[13]                    = "onStopFire";
	stateTransitionOnTimeout[13]       = "ReadyUber";
	stateTransitionOnNotLoaded[13]     = "StopFire";
	stateTimeoutValue[13]              = 0.1;
	stateWaitForTimeout[13]            = false;
	stateAllowImageChange[13]          = true;
	stateSequence[13]                  = "ChargeOff";
	stateEmitter[13]                   = TF2MedigunUberReadyEmitter;
	stateEmitterTime[13]               = 0.1;
	stateEmitterNode[13]               = "muzzleNode";
};

function TF2MedigunImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	
	//Ammo = has heal target
	//Loaded = has uber ready
	%obj.setImageAmmo(%slot,0);
	%obj.setImageLoaded(%slot,(%obj.tf2Ubercharge == 100) || %obj.usingUber);
	
	if(%obj.usingUber)
	{
		%b = %obj.tf2Ubercharge;
		%obj.tf2Ubercharge = %obj.tf2Ubercharge - 2/256*(getSimTime()-%obj.lastUberUpdate);
		%obj.lastUberUpdate = getSimTime();
		if(%obj.tf2Ubercharge > 0)
		{
			%obj.mountImage(PlayerTF2UberImage,3);
		}
		else
		{
			%obj.tf2Ubercharge = 0;
			%obj.usingUber = 0;
			%obj.endUber();
		}
	}
	
	%obj.healTarget = "";
	%obj.lastHealEmitTime = "";
}

function TF2MedigunImage::onReady(%this,%obj,%slot)
{
	if(%obj.usingUber)
	{
		if(%obj.lostUberTarget)
			%rate = 2/256;
		else
			%rate = 2/128;
		%obj.tf2Ubercharge = %obj.tf2Ubercharge - 2/256*(getSimTime()-%obj.lastUberUpdate);
		%obj.lastUberUpdate = getSimTime();
		if(%obj.tf2Ubercharge < 0)
		{
			%obj.tf2Ubercharge = 0;
			%obj.endUber();
		}
		%start = "<color:FFFF00>";
	}
	else
		%start = "<color:FFFFFF>";
	
	if(isObject(%obj.client))
	{
		%a = %obj.tf2Ubercharge;
		%b = 100;
		%sep = "<color:111111>";
		%done = (%a >= %b) || (%a == 0);
		%end = (%a / %b) * 25;
		%str = (%a == 0 ? %sep : %start);
		
		for(%i=0;%i<25;%i++)
		{
			if(%i > %end && !%done)
			{
				%str = %str @ %sep;
				%done = 1;
			}
			%str = %str @ "|";
		}
		bottomprint(%obj.client, "<just:center>" @ %str, 2, 1);
	}
}

function TF2MedigunImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	if(%obj.usingUber)
	{
		%obj.lostUberTarget = 1;
		%obj.setImageLoaded(3,1);
	}
	
	%obj.stopAudio(1);
	
	%obj.healTarget.beingHealed = 0;
	%obj.healTarget = "";
	%obj.lastHealEmitTime = "";
}

function TF2MedigunImage::onStartupUber(%this,%obj,%slot)
{
	%scaleFactor = getWord(%obj.getScale(),2);
	%p = new Projectile()
	{
		dataBlock = TF2MedigunUberProjectile;
		initialPosition = %obj.getMuzzlePoint(0);
		initialVelocity = %obj.getForwardVector();
		sourceObject = %obj;
		client = %obj.client;
		sourceClient = %obj.client;
		sourceSlot = %slot;
		originPoint = %start;
	};
	MissionCleanup.add(%p);
	%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	%p.explode();
	
	if(!%obj.usingUber)
		%obj.playAudio(1,radioWaveTravelSound);
}

function TF2MedigunImage::onCheckFire(%this,%obj,%slot)
{
	%point = %obj.getMuzzlePoint(%slot);
	
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	%found = 0;
	
	initContainerRadiusSearch(%point, 12, $TypeMasks::PlayerObjectType);
	while(isObject(%searchObj = containerSearchNext()))
	{
		if(%searchObj == %obj) //selfish medic
			continue;
		
		if(%searchObj == %obj.getObjectMount())
			continue;
		
		if(vectorDist(%obj.getHackPosition(),%searchObj.getHackPosition()) > 10)
			continue;
		
		if(%searchObj.getState() $= "Dead")
			continue;
		
		%mini1 = getMinigameFromObject(%obj);
		%mini2 = getMinigameFromObject(%searchObj);
		if((isObject(%mini1) || isObject(%mini2)) && %mini1 != %mini2 && !miniGameCanDamage(%obj,%searchObj))
			continue;
		
		if(isObject(GameModeStorerSO) && isObject(%mini1) && isObject(%obj.client) && isObject(%searchObj.client) && %obj.client.tdmTeam != %searchObj.client.tdmTeam)
			continue;
		
		%dir = vectorNormalize(vectorSub(%searchObj.getPosition(),%obj.getPosition()));
		if(vectorDot(%aimVec,%dir) < 0)
			continue;
		
		%found = 1;
		%obj.healTarget = %searchObj;
		%obj.healTarget.lastTF2Healer = %obj;
		%obj.lastUberUpdate = getSimTime();
		%obj.setImageAmmo(%slot,1);
		return;
	}
	
	if(isObject(%obj.client) && (getSimTime() - %obj.client.lastMedigunErrorTime) > 1000)
	{
		%obj.client.lastMedigunErrorTime = getSimTime();
		%obj.client.play2d(errorSound);
	}
	
	%this.onReady(%obj,%slot);
}

//Switching weapons could hide the sound so I play it here instead
function TF2MedigunImage::onStartFire(%this,%obj,%slot)
{
	serverPlay3d(TF2MedigunActivateSound,%obj.getPosition());
}

function TF2MedigunImage::onFire(%this,%obj,%slot)
{
	%point = %obj.getMuzzlePoint(%slot);
	
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	if(!isObject(%obj.healTarget) || %obj.healTarget.getState() $= "Dead" || vectorDist(%obj.getHackPosition(),%obj.healTarget.getHackPosition()) > 10 || %obj.healTarget == %obj.getObjectMount())
	{
		%obj.healTarget.beingHealed = "";
		%obj.healTarget.lastTF2Healer = "";
		%obj.healTarget = "";
		%obj.setImageAmmo(%slot,0);
		return;
	}
	
	%target = %obj.healTarget;
	%maxHP = %target.getFirstDatablock().maxDamage;
	%hp = (%target.dataBlock.maxDamage - %target.getDamageLevel());
	
	if(%obj.lastDamageTime $= "")
		%obj.lastDamageTime = %obj.spawnTime;
	
	%time = (getSimTime() - %obj.lastDamageTime);
	%time = (%time < 10000 ? 10000 : %time);
	%rate = ((%time-10000) / 5000 * 2) + 1;
	%rate = (%rate > 3 ? 3 : %rate);
	
	%target.doOverhealDecay();
	
	if((%target.dataBlock.maxDamage - %target.getDamageLevel()) < %maxHP)
	{
		%target.addHealth(%rate * 0.96); //(24 x 0.05 x 125 / 100) = TF2 healing rate compared to Blockland HP 
		%rate = 2/1280;
	}
	else
	{
		%target.tf2overheal = %target.tf2overheal+(%rate*0.96);
		%target.lastOverhealTime = getSimTime();
		if(%target.tf2overheal >= %maxhp/2)
		{
			%target.tf2overheal = %maxhp/2;
			%rate = 2/2560;
		}
		else
		{
			%rate = 2/1280;
		}
	}
	
	if(%obj.usingUber)
	{
		if(%obj.lostUberTarget)
			%rate = -2/256;
		else
			%rate = -2/128;
		
		%start = "<color:FFFF00>";
	}
	else
	{
		%start = "<color:FFFFFF>";
	}
	
	%obj.tf2Ubercharge = %obj.tf2Ubercharge + %rate*(getSimTime()-%obj.lastUberUpdate);
	%obj.lastUberUpdate = getSimTime();
	if(%obj.tf2Ubercharge < 0)
	{
		%obj.tf2Ubercharge = 0;
		if(%obj.usingUber)
			%obj.endUber();
	}
	
	if(%obj.tf2Ubercharge > 100) %obj.tf2Ubercharge = 100;
	
	if(%obj.tf2Ubercharge >= 100 && !%obj.doneUberReady)
	{
		%obj.tf2Ubercharge = 100;
		%obj.setImageLoaded(%slot,1);
		TF2MedigunImage.onStartupUber(%obj,%slot);
	}
	
	%hp = (%target.dataBlock.maxDamage - %target.getDamageLevel()) + %target.tf2overheal;
	
	if(%hp > %maxHP)
		%hpcol = "\c6";
	else if(%hp > %maxHP / 2)
		%hpcol = "\c2";
	else if(%hp > %maxHP / 3)
		%hpcol = "\c3";
	else
		%hpcol = "\c0";
	
	%hpstr = %hpcol @ mFloor(%hp) @ "\c0/\c3" @ mFloor(%maxHP);
	
	if(isObject(%obj.client))
	{
		if(isObject(GameModeStorerSO))
			%oname = clientTeamName(%obj.client,0);
		else if(%obj.client.isSpaceBotAI)
			%oname = "\c3" @ %obj.client.getBotName();
		else
			%oname = "\c3" @ %obj.client.getPlayerName();
		
		%a = %obj.tf2Ubercharge;
		%b = 100;
		%sep = "<color:111111>";
		%done = (%a >= %b) || (%a == 0);
		%end = (%a / %b) * 25;
		%str = (%a == 0 ? %sep : %start);
		
		for(%i=0;%i<25;%i++)
		{
			if(%i > %end && !%done)
			{
				%str = %str @ %sep;
				%done = 1;
			}
			%str = %str @ "|";
		}
		bottomprint(%obj.client, "<just:center>" @ %str, 2, 1);
	}
	else
	{
		if(fileName(%obj.getFirstDatablock().shapeFile) $= "m.dts" || %obj.getFirstDatablock().uiName $= "")
			%oname = "\c0 A \c3Bot";
		else
			%oname = "\c0 A \c3" @ %obj.getFirstDatablock().uiName;
	}
	
	if(isObject(%target.client))
	{
		if(isObject(GameModeStorerSO))
			%tname = clientTeamName(%target.client,0);
		else if(%target.client.isSpaceBotAI)
			%tname = "\c3" @ %target.client.getBotName();
		else
			%tname = "\c3" @ %target.client.getPlayerName();
	}
	else
	{
		if(fileName(%target.getFirstDatablock().shapeFile) $= "m.dts" || %target.getFirstDatablock().uiName $= "")
			%tname = "\c3Bot";
		else
			%tname = "\c3" @ %target.getFirstDatablock().uiName;
	}
	
	if(%target.lastTF2Healer == %obj || !isObject(%target.lastTF2Healer))
	{
		%target.lastTF2Healer = %obj;
		if(%obj.usingUber)
		{
			%uber = "\c0bercharge: \c6DEPLOYED! \c0(\c3 " @ mFloatLength(%obj.tf2Ubercharge,0) @ "%\c0)";
			
			if(isObject(%obj.client))
				%obj.client.centerPrint("<br><br><br><br><br>\c0Healing: " @ %tname SPC "\c0(" @ %hpstr @ "\c0)<br>" @ %uber,0.5);
			
			if(isObject(%target.client))
				%target.client.centerPrint(%uber,0.5);
		}
		else
		{
			%uber = "\c0bercharge:\c3 " @ mFloatLength(%obj.tf2Ubercharge,0) @ "%";
			
			if(isObject(%obj.client))
				%obj.client.centerPrint("<br><br><br><br><br>\c0Healing: " @ %tname SPC "\c0(" @ %hpstr @ "\c0)<br>" @ %uber,0.5);
			
			if(isObject(%target.client))
				%target.client.centerPrint("<br><br><br><br><br>" @ %oname @ "\c0 is healing you.<br>\c0Your health: " @ %hpstr @ "<br>" @ %uber,0.5);
		}
	}
	
	%target.beingHealed = 1;
	
	if(%obj.usingUber)
		%target.mountImage(PlayerTF2UberImage,3);
	else if(!isObject(%target.getMountedImage(3)))
		%target.mountImage(PlayerTF2HealImage,3);
	
	%start = %obj.getMuzzlePoint(0);
	%end = %target.getHackPosition();
	%pos = %end;
	%dir = vectorNormalize(vectorSub(%pos,%start));
	%projectile = TF2MedigunHealProjectileA;
	
	for(%i=0;%i<3;%i++)
	{
		%t = vectorDist(%start,%end) / vectorLen(vectorScale(getWord(%dir,0) SPC getWord(%dir,1),%projectile.muzzleVelocity));
		%end = vectorAdd(%pos,vectorScale(%target.getVelocity(),%t));
		%dir = vectorNormalize(vectorSub(%end,%start));
	}
	
	%scaleFactor = getWord(%obj.getScale(),2);
	
	%p = new Projectile()
	{
		dataBlock = TF2MedigunHealProjectileA;
		initialPosition = %start;
		initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity);
		sourceObject = %obj;
		client = %obj.client;
		sourceClient = %obj.client;
		sourceSlot = %slot;
		originPoint = %start;
	};
	MissionCleanup.add(%p);
	%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	
	if(getSimTime() - %obj.lastHealEmitTime > 200)
	{
		%obj.lastHealEmitTime = getSimTime();
		%p2 = new Projectile()
		{
			dataBlock = TF2MedigunHealProjectileB;
			initialPosition = %start;
			initialVelocity = vectorScale(%dir,%projectile.muzzleVelocity);
			sourceObject = %obj;
			client = %obj.client;
			sourceClient = %obj.client;
			sourceSlot = %slot;
			originPoint = %start;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	}
}

function TF2MedigunImage::onFireUber(%this,%obj,%slot)
{
	%obj.doneUberReady = 1;
	TF2MedigunImage.onFire(%obj,%slot);
	%obj.doneUberReady = 0;
}

function TF2MedigunImage::onStopFire(%this,%obj,%slot)
{
	%obj.setImageAmmo(%slot,0);
	
	%obj.healTarget.beingHealed = 0;
	%obj.healTarget.lastTF2Healer = "";
	%obj.healTarget = "";
	%obj.lastHealEmitTime = "";
	
	if(%obj.usingUber)
		%obj.lostUberTarget = 1;
}

function Player::doOverhealDecay(%this)
{
	if(%this.beingHealed)
		return;
	
	%time = getSimTime() - %this.lastOverhealTime;
	%maxHP = %this.getFirstDatablock().maxDamage;
	%hp = (%this.getFirstDatablock().maxDamage - %this.getDamageLevel());
	if(%hp < %maxHP)
	{
		%this.tf2overheal = "";
		%this.lastOverhealTime = "";
		return;
	}
	
	if(%time > 20000)
		%time = 20000;
	
	%this.tf2overheal = (%this.tf2overheal - (%time/20000 * %maxHP/2));
	%this.tf2overheal = (%this.tf2overheal < 0 ? 0 : %this.tf2overheal);
	
	%this.lastOverhealTime = getSimTime();
}

function Player::endUber(%this)
{
	%this.usingUber = 0;
	%this.tf2Ubercharge = 0;
	%this.lostUberTarget = "";
	
	if(%this.getMountedImage(0) $= TF2MedigunImage.getID())
	{
		%this.setImageLoaded(0,0);
		%this.stopAudio(1);
	}
}

package TF2Medigun
{
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot $= 4 && %player.getMountedImage(0) $= TF2MedigunImage.getID())
		{
			if(%val)
			{
				%player.mediTrigEnable = getSimTime();
			}
			else
			{
				if(getSimTime() - %player.mediTrigEnable < 500 && %player.tf2Ubercharge >= 100)
				{
					%player.usingUber = 1;
					%player.lostUberTarget = 0;
					%player.mountImage(PlayerTF2UberImage,3);
				}
				%player.mediTrigEnable = "";
			}
		}
		else
			Parent::onTrigger(%this,%player,%slot,%val);
	}
	
	function Player::emote(%this,%em,%skipSpamProtect)
	{
		if(%this.getMountedImage(3) == PlayerTF2UberImage.getID() && %em.getClassName() $= "ShapeBaseImageData")
			return;
		
		Parent::emote(%this,%em,%skipSpamProtect);
	}
	
	function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
	{
		if((%obj.getMountedImage(3) == PlayerTF2UberImage.getID() || %obj.usingUber) && %damageType != $DamageType::Suicide)
			%damage = 0;
		else
		{
			%obj.doOverhealDecay();
			if(%obj.tf2Overheal > 0)
			{
				if(%damage > %obj.tf2Overheal)
				{
					%damage = %damage - %obj.tf2Overheal;
					%obj.tf2Overheal = 0;
				}
				else
				{
					%flash = %obj.getWhiteOut() + ((%damage / %this.maxDamage));
					if(%flash > 0.5)
						%flash = 0.5;
					%obj.setWhiteOut(%flash);
					
					%obj.tf2Overheal = %obj.tf2Overheal - %damage;
					%damage = 0;
				}
			}
		}
		Parent::damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
	}
};
ActivatePackage(TF2Medigun);