datablock AudioProfile(tf2UbersawHitPlayerSound)
{
   filename    = "./tf2UbersawHit.wav";
   description = AudioClosest3d;
   preload = true;
};

AddDamageType("TF2Ubersaw",   '<bitmap:Add-Ons/Weapon_TF2BasicMelee/ci_tf2bonesaw> %1',    '%2 <bitmap:Add-Ons/Weapon_TF2BasicMelee/ci_tf2bonesaw> %1',0.75,1);

//////////
// item //
//////////
datablock ItemData(tf2UbersawItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ubersaw.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "The Ubersaw";
	iconName = "./icon_ubersaw";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = tf2UbersawImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(tf2UbersawImage)
{
   // Basic Item properties
   shapeFile = "./ubersaw.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.05 0.05 0.1";
   rotation = eulerToMatrix("30 0 0");
   eyeOffset = "0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   className = "TF2MeleeWeaponImage";

   // Projectile && Ammo.
   item = tf2UbersawItem;
   ammo = " ";
   projectile = hammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";
   
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = hammerProjectile;
   raycastExplosionBrickSound = tf2MeleeHitBrickSoundA;
   raycastExplosionPlayerSound = tf2UbersawHitPlayerSound;
   raycastDirectDamage = 35;
   raycastDirectDamageType = $DamageType::TF2Ubersaw;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.4;
	stateSequence[0]                 = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateSound[2]			= tf2MeleeSwingSound;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Wait";
	stateTimeoutValue[4]            = 0.4;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	
	stateName[5]			= "Wait";
	stateTransitionOnTimeout[5]	= "CheckFire";
	stateTimeoutValue[5]		= 0.50;
	stateScript[5]			= "onStopFire";
	stateAllowImageChange[5]	= false;
	stateWaitForTimeout[5]		= true;

	stateName[6]			= "CheckFire";
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateTransitionOnTriggerDown[6]	= "PreFire";
	
	stateName[7]                    = "StopFire";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.3;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateSequence[7]                = "StopFire";
	stateScript[7]                  = "onStopFire";
};

function tf2UbersawImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, wrench);
}

function tf2UbersawImage::onFire(%this, %obj, %slot)
{
	if(getRandom(0,1))
		%this.raycastExplosionBrickSound = tf2MeleeHitBrickSoundA;
	else
		%this.raycastExplosionBrickSound = tf2MeleeHitBrickSoundB;
	
	WeaponImage::onFire(%this, %obj, %slot);
	%obj.playthread(2, activate);
}

function tf2UbersawImage::onStopFire(%this, %obj, %slot)
{
}

function tf2UbersawImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	if(%col.getType() & $TypeMasks::PlayerObjectType && %obj.getState() !$= "Dead")
	{
		if(%obj.usingUber)
		{
			%rate = 2/128;
			%obj.tf2Ubercharge = %obj.tf2Ubercharge - 2/256*(getSimTime()-%obj.lastUberUpdate);
			if(%obj.tf2Ubercharge < 0)
			{
				%obj.tf2Ubercharge = 0;
				%obj.endUber();
			}
			%start = "<color:FFFF00>";
		}
		else
			%start = "<color:FFFFFF>";
		
		%en1 = %obj.tf2Ubercharge;
		%obj.tf2Ubercharge += 25;
		
		if(%obj.tf2Ubercharge > 100) %obj.tf2Ubercharge = 100;
		if(isObject(%obj.client))
		{
			%a = %en1;
			%b = %obj.tf2Ubercharge;
			%c = 100;
			%end1 = (%a / %c) * 25;
			%end2 = (%b / %c) * 25;
			%sep1 = "<color:00FF00>";
			%sep2 = "<color:111111>";
			%done1 = (%end1 == 0);
			%done2 = (%end2 == 0);
			if(%done2)
				%str = %sep2;
			else if(%done1)
				%str = %sep1;
			else
				%str = %start;
			
			for(%i=0;%i<25;%i++)
			{
				if(%i > %end1 && !%done1)
				{
					%str = %str @ %sep1;
					%done1 = 1;
				}
				if(%i > %end2 && !%done2)
				{
					%str = %str @ %sep2;
					%done2 = 1;
				}
				%str = %str @ "|";
			}
			bottomPrint(%obj.client, "<just:center>" @ %str, 2, 1);
		}
		%obj.lastUberUpdate = getSimTime();
	}
	
	Parent::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%hit,%crit);
}